import java.io.*;
import java.util.*;
import java.math.*;

public class decorator_ab implements Runnable {

	final long MAXN = 100000;
	final long MAXM = 100000;
	final long MAXV = 1000000000;

	private void solve() throws IOException {
		int n = in.nextInt();
		assert 1 <= n && n <= MAXN;

		Tree tr = new Tree(n);
		for (int i = 0; i < n; ++i) {
			long v = in.nextLong();
			assert Math.abs(v) <= MAXV;
			tr.set(i, i, v);
		}
		int m = in.nextInt();
		for (int i = 0; i < m; ++i) {
			int q = in.nextInt();
			int l = in.nextInt() - 1;
			int r = in.nextInt() - 1;
			int k = in.nextInt();

			assert q == 0 || q == 1;
			assert Math.abs(k) <= MAXV;

			if (q == 0) {
				assert 0 <= l && l <= r && r < n;
				tr.set(l, r, k);
			} else {
				assert k > 0;
				assert 0 <= l && l + k <= n;
				assert 0 <= r && r + k <= n;

				if (tr.get(l, l + k - 1) == tr.get(r, r + k - 1)) {
					out.print("+");
				} else {
					out.print("-");
				}
			}
		}
		out.println();
	}

	class Tree {
		long X = BigInteger.valueOf(1140071481932319848L).nextProbablePrime()
				.longValue();
		long[] v, d, pX, cpX;

		int m;

		public Tree(int n) {
			m = 1;
			while (m < n)
				m <<= 1;
			v = new long[2 * m];
			d = new long[2 * m];
			pX = new long[m + 1];
			cpX = new long[m + 1];
			pX[0] = 1;
			cpX[0] = 1;
			for (int i = 1; i < pX.length; ++i) {
				pX[i] = pX[i - 1] * X;
				cpX[i] = cpX[i - 1] + pX[i];
			}
		}

		void relax(int x, int l, int r) {
			if (d[x] > 0) {
				v[x] = d[x] * cpX[r - l];
				if (x < m) {
					d[2 * x] = d[x];
					d[2 * x + 1] = d[x];
				}
				d[x] = 0;
			}
		}

		void set(int l, int r, long c) {
			if (l > r)
				return;
			this.l = l;
			this.r = r;
			this.c = c;
			set_(1, 0, m - 1);
		}

		int l, r;
		long c;

		void set_(int x, int lx, int rx) {
			if (l <= lx && rx <= r) {
				d[x] = c;
				relax(x, lx, rx);
				return;
			}
			relax(x, lx, rx);
			if (rx < l || r < lx)
				return;
			int m = (lx + rx) / 2;
			set_(2 * x, lx, m);
			set_(2 * x + 1, m + 1, rx);
			v[x] = v[2 * x] + pX[m + 1 - lx] * v[2 * x + 1];
		}

		long get(int l, int r) {
			ans = 0;
			this.l = l;
			this.r = r;
			get_(1, 0, m - 1);
			return ans;
		}

		long ans;

		void get_(int x, int lx, int rx) {
			if (rx < l || r < lx)
				return;
			relax(x, lx, rx);
			if (l <= lx && rx <= r) {
				ans += pX[lx - l] * v[x];
				return;
			}
			int m = (lx + rx) / 2;
			get_(2 * x, lx, m);
			get_(2 * x + 1, m + 1, rx);
		}
	}

	final String FILE_NAME = "decorator";

	SimpleScanner in;
	PrintWriter out;

	@Override
	public void run() {
		try {
			in = new SimpleScanner(new FileReader(FILE_NAME + ".in"));
			out = new PrintWriter(FILE_NAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	public static void main(String[] args) {
		new Thread(new decorator_ab()).start();
	}

	class SimpleScanner extends BufferedReader {

		private StringTokenizer st;
		private boolean eof;

		public SimpleScanner(Reader a) {
			super(a);
		}

		String next() {
			while (st == null || !st.hasMoreElements()) {
				try {
					st = new StringTokenizer(readLine());
				} catch (Exception e) {
					eof = true;
					return "";
				}
			}
			return st.nextToken();
		}

		boolean seekEof() {
			String s = next();
			if ("".equals(s) && eof)
				return true;
			st = new StringTokenizer(s + " " + st.toString());
			return false;
		}

		private String cnv(String s) {
			if (s.length() == 0)
				return "0";
			return s;
		}

		int nextInt() {
			return Integer.parseInt(cnv(next()));
		}

		double nextDouble() {
			return Double.parseDouble(cnv(next()));
		}

		long nextLong() {
			return Long.parseLong(cnv(next()));
		}
	}
}